var t;

function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i = 0; i <ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length,c.length);
        }
    }
    return "";
}

function allowChannelChange() {
    var url = window.location.href;

    // On channelbanner, always allow
    if(url.indexOf("channelbanner.html") > -1 || ($("#pip").length && !$('.rotana_channel_list').length)) {
    	if (isVODPlaying()) {
			logConsole("VOD Playing - CH UP/DOWN disabled");
            return false;
    	}
        return true;
    }
    return false;
}

function launchNetflix() {
    logConsole("in launchNetflix");

    hcap.preloadedApplication.launchPreloadedApplication({
        "id":"244115188075859013",
        "parameters": "{'params':{'reason':'hotkey'}}",
        "onSuccess":function() {
            logConsole("launchPreloadedApplication Success");

			// clear existing app id
			localStorage.removeItem("active_smartapp_id");

			// update with new ID
            localStorage.setItem("active_smartapp_id", "244115188075859013");
        },
        "onFailure":function(f) {
            logConsole("launchPreloadedApplication Failure : errorMessage = " + f.errorMessage);
        }
    });
}


function processKeyDown(event, redirect, referrer) {
    //logConsole("In processKeyDown, event.keyCode: " + event.keyCode + " ....");
    //logConsole("referrer: " + referrer);

    try {
        if (LOCK_NAVIGATION) {
            logConsole("Navigation is locked!");
            return;
        }
        euroGuideButtonSet = getCookie("euroGuideButtonSet");

        switch(event.keyCode) {
            case hcap.key.Code.EXIT:
            case hcap.key.Code.PORTAL:
            case hcap.key.Code.GUIDE:
            case hcap.key.Code.INFO:
            case hcap.key.Code.BACK:
            case hcap.key.Code.ENTER:
                SECRET_KEY_BUFFER = "";
                break;
            case hcap.key.Code.NUM_0:
            case hcap.key.Code.NUM_1:
            case hcap.key.Code.NUM_2:
            case hcap.key.Code.NUM_3:
            case hcap.key.Code.NUM_4:
            case hcap.key.Code.NUM_5:
            case hcap.key.Code.NUM_6:
            case hcap.key.Code.NUM_7:
            case hcap.key.Code.NUM_8:
            case hcap.key.Code.NUM_9:
            case hcap.key.Code.BLUE:
                break;
            default:
                SECRET_KEY_BUFFER = "";
                if (euroGuideButtonSet == 'false' || euroGuideButtonSet == '') {
                    PORTALTIMEOUT_OFFSET = 0;
                    resetTimer();
                }
                break;
        }

        var url = window.location.href;

        switch(event.keyCode) {
//            case 19: // GUIDE MOVE LOCIC
//                showGroupingFilters();
//                break;
            case hcap.key.Code.CH_UP :
                if (allowChannelChange()) {
                	logConsole("***************** hcap.key.Code.CH_UP *************");
                	current_channel = getCookie("current_channel");
                    ch = channelUp(current_channel);
                    var org_current_channel = parseInt(current_channel);
                    var tmp_current_channel = parseInt(ch.logicalChannelNumber);

	                while(ch.type == "SMART_APP" || ch.type == "URL") {
                        ch = channelUp(tmp_current_channel);
                        if(org_current_channel == parseInt(ch.logicalChannelNumber)) {
                            break;
                        }
                        tmp_current_channel = parseInt(ch.logicalChannelNumber);
	                }

                    if(ch.type != "SMART_APP" && ch.type != "URL") {
                        changeChannel(ch, null, 0, 'CH_UP - HCAP_key_handler.js', function() {
                            if (redirect) {
                                window.location.href = "channelbanner.html?chNum=" + ch.logicalChannelNumber;
                            }
                        });
                    }
                }
                break;
            case hcap.key.Code.CH_DOWN :
                if (allowChannelChange()) {
                	logConsole("***************** hcap.key.Code.CH_DOWN *************");
                	current_channel = getCookie("current_channel");
                    ch = channelDown(current_channel);

                    var org_current_channel = parseInt(current_channel);
                    var tmp_current_channel = parseInt(ch.logicalChannelNumber);

                    while(ch.type == "SMART_APP" || ch.type == "URL") {
                        ch = channelDown(tmp_current_channel);
                        if(org_current_channel == parseInt(ch.logicalChannelNumber)) {
                            break;
                        }
                        tmp_current_channel = parseInt(ch.logicalChannelNumber);
                    }

                    if(ch.type != "SMART_APP" && ch.type != "URL") {
                        changeChannel(ch, null, 0, 'CH_DOWN - HCAP_key_handler.js', function() {
                            if (redirect) {
                                window.location.href = "channelbanner.html?chNum=" + ch.logicalChannelNumber;
                            }
                        });
                    }
                }
                break;
            case hcap.key.Code.RIGHT :
                break;
            case hcap.key.Code.DOWN :
            	if (url.indexOf("stats.html") > -1) {
					network_history_log = $("#network_history_log");
					//logConsole("Scrolling down network_history_log...");
					network_history_log.scrollTop(network_history_log.scrollTop() + 20);
            	}
                break;
            case hcap.key.Code.LEFT :
                break;
            case hcap.key.Code.UP :
            	if (url.indexOf("stats.html") > -1) {
					network_history_log = $("#network_history_log");
					//logConsole("Scrolling up network_history_log...");
					if (network_history_log.scrollTop() - 20) {
						network_history_log.scrollTop(0);
					}
					else {
						network_history_log.scrollTop(network_history_log.scrollTop() - 20);
					}
            	}
                break;
            case hcap.key.Code.GUIDE :

                guideButtonChannel = parseInt(getCookie("guideButtonChannel"));

                // Go to TV's native guide
                if (euroGuideButtonSet == 'true') {
                    logConsole("found euroGuideButtonSet");

                    if(PORTAL_ACTIVE) {
                        SetPortalStatus(HIDE_PORTAL, "GUIDE");
                    }

                    if(isVODPlaying()) {
                       //clear media and go to the info page which is set.
                       exitVOD(function() {
                         setCookie("switchVODToEPG", 'true', COOKIE_EXPIRE_DAYS);
                         setBackgroundToTV();
                         switchNativeEPG("GUIDE");
                       }, "none");
                    }
                }
                // Go to TV's mapped guide channel if set
                else if (!isNaN(guideButtonChannel) && guideButtonChannel != -1 && getCookie("hcap_focused") == 1) {
                    logConsole("found guideButtonChannel: " + guideButtonChannel);
                    ch = getPhysicalChannelInfo(guideButtonChannel);
                    if (!_.isUndefined(ch) && !_.isEmpty(ch)) {
                        setCookie('previous_channel', -1, COOKIE_EXPIRE_DAYS);

                        if(PORTAL_ACTIVE) {
                            callback = function() {SetPortalStatus(HIDE_PORTAL);};
                        }
                        else if (!isPreviewMode()) {
                            callback = function() {
                                setCookie("guide_to_channel", "1", 365);
                                $(window.frameElement).addClass("hidden");
                                window.location = "channelbanner.html?mode=tv&chNum="+guideButtonChannel;
                            };
                        }

                        if (isVODPlaying()) {
                            exitVOD(function() {
                                changeChannel(ch, 0, 0, 'GUIDE - HCAP_key_handler.js', callback);
                            }, 'none', event.keyCode);
                	    }
                        else {
                    	     changeChannel(ch, 0, 0, 'GUIDE - HCAP_key_handler.js', callback);
					    }
                    }
                    // redirect to guide/portal
                    else {
                        logConsole("invalid channel, redirecting...");
                    }
                }
                else if (getCookie("guide_page_name") != '' && (getCookie("hcap_focused") == 1 || isPreviewMode())) {
                    page_url = getCookie("guide_page_name");
                    if (url.indexOf(page_url) == -1) {
                        /* WEBCOMM17-4125 */
                        setCookie("guide_to_page", "1", 365);
                        logConsole("Bringing up Guide page: " + page_url);

                        if (isVODPlaying()) {
						    //clear media and go to the info page which is set.
                           exitVOD(function() {
                               if(PORTAL_ACTIVE){
                                   goto(page_url.replace(".html",""));
                               }else {
                                   setTimeout(function(){
                                       window.location = "portal.html?page="+page_url.replace(".html","");
                                   }, 250);

                                   setTimeout(function(){
                                       SetPortalStatus(SHOW_PORTAL);
                                   },50);
                               }
                           }, page_url.replace(".html",""));
                        }
                        else {
                            if(page_url == "channelbanner.html") {
                                if(PORTAL_ACTIVE) {
                                    SyncBackgroundSettingsToParent('none');

                                    setTimeout(function() {
                                        SetPortalStatus(HIDE_PORTAL);
                                    }, 50);
                                }
                            } else {
                                if(PORTAL_ACTIVE){
                                    goto(page_url.replace(".html",""));
                                }else {
                                    setTimeout(function(){
                                        window.location = "portal.html?page="+page_url.replace(".html","");
                                    }, 250);
                                
                                    setTimeout(function(){
                                        SetPortalStatus(SHOW_PORTAL);
                                    },50);
                                }
                            }
                        }

                        PORTALTIMEOUT_OFFSET = 0;
                        resetTimer();
                    }
                    else {
                        if(PORTAL_ACTIVE) {
                            SetPortalStatus(HIDE_PORTAL);
                        }
                    }
                }

                /*Need to support 4 cases
                 1. EPG
                 2. Channel Map
                 3. Native EU only -> will be in locale settings
                 4. Channel Tune
                 */
                break;
            case hcap.key.Code.BACK :
                logConsole("hcap.key.Code.BACK: back_button_page -  " + back_button_page);

                if ((getCookie("portal_mode") != PORTAL_MODE_TV && !isVODPlaying() && goToReferrerPage()) ||
                (url.indexOf("popup_007.html") !== -1 && (back_button_page == "" || back_button_page == "none"))) {
                    return;
                }

                logConsole("Got past goToReferrerPage...");

                if (isVODPlaying()) {
                    logConsole("VOD IS PLAYING...");
                    resetTimer();

                    exitVOD(function() {
                        goToReferrerPage(true);
                    }, getBackPageReferrer());
                }
                else if (back_button_page != "" && back_button_page != "none") {

                    if(PORTAL_ACTIVE) {
                        if(back_button_page == "channelbanner.html") {
                            event.stopImmediatePropagation();
                            event.stopPropagation();

                            if (!isPreviewMode()) {
                                setTimeout(function() {
                                    SyncBackgroundSettingsToParent('none');
                                    SetPortalStatus(HIDE_PORTAL);
                                }, 50);
                            }

                            return;
                        } else {
                            PORTALTIMEOUT_OFFSET = 0;
                            resetTimer();

                            if(isPreviewMode()) {
                                setTimeout(function(){
                                    window.location = "portal.html?page="+back_button_page.replace(".html","");
                                }, 250);
                            } else {
                                goto(back_button_page.replace(".html",""));

                                //For RF functionality
                                if(parent.CHANNEL_TYPE === 'RF_DATA' && PORTAL_ACTIVE) {
                                    if(window.parent.RFVariable.currentPageName === "weather" || window.parent.RFVariable.currentPageName === "billing") {
                                        if(window.parent.GLOBAL_SOUND_SETTING == 2) {
                                            releaseDatachannelForCarousel(false);
                                        } else {
                                            releaseDatachannelForCarousel(true);
                                        }
                                    } else if(window.parent.RFVariable.currentPageName === "lg_video") {
                                        if(window.parent.IS_VIDEO_WIDGET_IN_PORTAL == 'N' && window.parent.IS_TV_WIDGET_IN_PORTAL == 'N') {
                                            restoreCurrentChannel();
                                        }
                                    }
                                    window.parent.RFVariable.currentPageName = "portal";
                                }
                            }

                            return;
                        }
                    }

                }
                if(url.indexOf("channelbanner.html")== -1 && document.referrer.indexOf("index.html") == -1 && document.referrer.indexOf("channelbanner.html") == -1){
                    if(PORTAL_ACTIVE) {
                        var back_url = 'none';
                        var current_url = location.pathname.slice(location.pathname.lastIndexOf("/") + 1, location.pathname.lastIndexOf(".html"));

                        if(document.referrer !== "") {
                            back_url = document.referrer;
                            back_url = back_url.slice(back_url.lastIndexOf("/") + 1, back_url.lastIndexOf(".html"));
                        }

                        if(window.spa) {
                            goto();
                            return true;
                        }

                        PORTALTIMEOUT_OFFSET = 0;
                        resetTimer();

                        // Sync index.html to portal settings
                        SyncBackgroundSettingsToParent(back_url);

                        if(!isEditorMode() && !isPreviewMode()) {
                            var parentBody = $(window.parent.document.body);
                            parentBody.css('background-color', 'black');
                        }

                        resizePIPtoFullScreen();
                        if (back_url == current_url) {
                            setTimeout(function() {
                                $(window.frameElement).addClass('hidden');
                                window.location = "portal.html?" + Date.now();
                            }, 250);
                        }else{
                            window.history.back();
                        }
                    }
                }
                else if (document.referrer.indexOf("channelbanner.html") != -1 && referrer == 'epg') {
	                event.stopImmediatePropagation();
	                event.stopPropagation();

	                setTimeout(function() {
	                    SetPortalStatus(HIDE_PORTAL);
	                }, 50);
                }
                else if (window.spa) {
                    goto();
                    return true;
                }

                //For RF functionality
                if(parent.CHANNEL_TYPE === 'RF_DATA' && PORTAL_ACTIVE) {
                   if(window.parent.RFVariable.currentPageName === "weather" || window.parent.RFVariable.currentPageName === "billing") {
                       if(window.parent.GLOBAL_SOUND_SETTING == 2) {
                          releaseDatachannelForCarousel(false);
                       } else {
                          releaseDatachannelForCarousel(true);
                       }
                   } else if(window.parent.RFVariable.currentPageName === "lg_video") {
                       if(window.parent.IS_VIDEO_WIDGET_IN_PORTAL == 'N' && window.parent.IS_TV_WIDGET_IN_PORTAL == 'N') {
                          restoreCurrentChannel();
                       }
                   }
                   window.parent.RFVariable.currentPageName = "portal";

                   var payChannelTimer = window.parent.RFVariable.PayChannelTimer;
                   if(!_.isUndefined(payChannelTimer) && !_.isNull(payChannelTimer) && payChannelTimer.isRunning()){
                       payChannelTimer.reset();
                   }
                }
                break;
            case hcap.key.Code.PAUSE:
            case "19":
            	logConsole("Pressed PAUSE");
            	if (isVODPlaying()) {
            		logConsole("Pausing video....");

            		mediaPause();
				}
            	break;
            case hcap.key.Code.PLAY:
            	logConsole("Pressed PLAY");
            	if (isVODPlaying()) {
            		logConsole("Resuming video....");

            		mediaResume();
				}
            	break;
            case hcap.key.Code.EXIT :
                if(url.indexOf("channelbanner.html")== -1){
                    if(PORTAL_ACTIVE) {
                        if(typeof adbannerHandler === 'object' && adbannerHandler.isOn) {
                            adbannerHandler.off();
                        }
                        else {
                            // Sync index.html to portal settings
                            SyncBackgroundSettingsToParent('none');

                            setTimeout(function() {
                                SetPortalStatus(HIDE_PORTAL);
                            }, 50);
                        }
                    }
                }
                else{
                	logConsole("In channelbanner...");
                	if (isVODPlaying()) {
                		logConsole("VOD IS PLAYING...");
                		exitVOD(function() {
                            goToReferrerPage(true);
                        }, getBackPageReferrer());
                    }
                	else {
                        if (getCookie("portal_mode") != PORTAL_MODE_TV) {
                            if (goToReferrerPage()) {
                                return;
                            }
                        }
                        else {
                            hidebanner();
                        }
					}
                }
                break;
            case hcap.key.Code.ENTER :
                if(!PORTAL_ACTIVE) {
                    if (typeof remote_input !== "undefined" && remote_input == 1) {
                        logConsole("readRemoteInput");
                        readRemoteInput();
                    }
                    else {
                        logConsole("displayBanner");

                        if (isVODPlaying()) {
                           displayBanner();
                        } else {
                            init_channel_banner();
                        }
                    }
                }
                break;
            case hcap.key.Code.PORTAL :
                if((window.spa && window.currentPage != "portal") || url.indexOf("portal.html")== -1){
                    if (isVODPlaying()) {
                        logConsole("VOD IS PLAYING...");

                        exitVOD(function() {
                            goToReferrerPage(true);
                        }, getBackPageReferrer());
                    }
                    else {
                        setCookie("guide_to_page", "1", 365);

					    /* DO NOT ADD THIS BACK !!!! */
					    /*
                        if(!isEditorMode() && !isPreviewMode()) {
                            var parentBody = $(window.parent.document.body);
                            parentBody.css('background-color', 'black');
                        }
                        */

                        if (isPreviewMode()) {
                            window.location = "src/portal.html";
                            return;
                        }
                        else {
                            if(PORTAL_ACTIVE){
                                goto("portal");
                            }else {
                                setTimeout(function(){
                                    $(window.frameElement).addClass('hidden');
                                    window.location = "portal.html";
                                }, 250);

                                setTimeout(function(){
                                    SetPortalStatus(SHOW_PORTAL);
                                },50);
                            }
                        }

                        //For RF functionality
                        if(parent.CHANNEL_TYPE === 'RF_DATA' && PORTAL_ACTIVE) {
                           if(window.parent.RFVariable.currentPageName === "weather" || window.parent.RFVariable.currentPageName === "billing") {
                              if(window.parent.GLOBAL_SOUND_SETTING == 2) {
                                 releaseDatachannelForCarousel(false);
                              } else {
                                 releaseDatachannelForCarousel(true);
                              }
                           } else if(window.parent.RFVariable.currentPageName === "lg_video") {
                       	       if(window.parent.IS_VIDEO_WIDGET_IN_PORTAL == 'N' && window.parent.IS_TV_WIDGET_IN_PORTAL == 'N') {
                                 restoreCurrentChannel();
                               }
                           }
                           window.parent.RFVariable.currentPageName = "portal";

                        }
                    }
                }
                // exit portal if already on portal
                else {
                    if (!isPreviewMode() && PORTAL_ACTIVE) {
                        setTimeout(function() {
                            SyncBackgroundSettingsToParent('none');
                            SetPortalStatus(HIDE_PORTAL);
                        }, 50);
                    }
                }
                break;
            case hcap.key.Code.FLASHBK :
            case hcap.key.Code.LAST_CH :
            case KEY_LAST : // THIS IS NOT A VALID VALUE FOR THIS FUNCTION, BUT UNTIL HCAP HAS THE PROPER UPDATE THIS NEEDS TO BE HERE
            	last_channel = getCookie("last_channel");
            	logConsole("last_channel: " + last_channel);
            	if (!isVODPlaying() && !PORTAL_ACTIVE && last_channel != "" && !isNaN((last_channel))) {
            		// lookup channel
					ch = getPhysicalChannelInfo(last_channel);
                    if(!_.isUndefined(ch) && !_.isEmpty(ch)) {
                        logConsole("Found last_channel....");
                        logConsole(JSON.stringify(ch));

                        // change to last channel
                        changeChannel(ch, 0, 0, 'LAST/FLASHBK/KEY_LAST - HCAP_key_handler.js', null);

                        logConsole("Changed channel......");
                    } else {
                        logConsole("Channel not found");
                    }

					// hide portal
	                setTimeout(function() {
						SetPortalStatus(HIDE_PORTAL);
	                }, 500);
            	}
            	break;
            case hcap.key.Code.NUM_0 :
                if(PORTAL_ACTIVE) {
                    SECRET_KEY_BUFFER = SECRET_KEY_BUFFER + "0";
                }else {
                    displayRemoteInput(0);
                }
                break;
            case hcap.key.Code.NUM_1 :
                if(PORTAL_ACTIVE) {
                    SECRET_KEY_BUFFER = SECRET_KEY_BUFFER + "1";
                }else {
                    displayRemoteInput(1);
                }
                break;
            case hcap.key.Code.NUM_2 :
                if(PORTAL_ACTIVE) {
                    SECRET_KEY_BUFFER = SECRET_KEY_BUFFER + "2";
                }else {
                    displayRemoteInput(2);
                }
                break;
            case hcap.key.Code.NUM_3 :
                if(PORTAL_ACTIVE) {
                    SECRET_KEY_BUFFER = SECRET_KEY_BUFFER + "3";
                }else {
                    displayRemoteInput(3);
                }
                break;
            case hcap.key.Code.NUM_4 :
                if(PORTAL_ACTIVE) {
                    SECRET_KEY_BUFFER = SECRET_KEY_BUFFER + "4";
                }else {
                    displayRemoteInput(4);
                }
                break;
            case hcap.key.Code.NUM_5 :
                if(PORTAL_ACTIVE) {
                    SECRET_KEY_BUFFER = SECRET_KEY_BUFFER + "5";
                }else {
                    displayRemoteInput(5);
                }
                break;
            case hcap.key.Code.NUM_6 :
                if(PORTAL_ACTIVE) {
                    SECRET_KEY_BUFFER = SECRET_KEY_BUFFER + "6";
                }else {
                    displayRemoteInput(6);
                }
                break;
            case hcap.key.Code.NUM_7 :
                if(PORTAL_ACTIVE) {
                    SECRET_KEY_BUFFER = SECRET_KEY_BUFFER + "7";
                }else {
                    displayRemoteInput(7);
                }
                break;
            case hcap.key.Code.NUM_8 :
                if(PORTAL_ACTIVE) {
                    SECRET_KEY_BUFFER = SECRET_KEY_BUFFER + "8";
                }else {
                    displayRemoteInput(8);
                }
                break;
            case hcap.key.Code.NUM_9 :
                if(PORTAL_ACTIVE) {
                    SECRET_KEY_BUFFER = SECRET_KEY_BUFFER + "9";
                }else {
                    displayRemoteInput(9);
                }
                break;
            case hcap.key.Code.RES_5:
            case hcap.key.Code.RES_6:
                /* NETFLIX */
                logConsole(" --------- pre launchNetflix -----------");

                hcap.power.getPowerMode({
                    "onSuccess" : function(s) {
                        logConsole("onSuccess power mode " + s.mode);
                        if(s.mode == hcap.power.PowerMode.WARM){
                            hcap.power.setPowerMode({
                                "mode" : hcap.power.PowerMode.NORMAL,
                                "onSuccess" : function() {
                                    logConsole("onSuccess");
                                    launchNetflix()
                                },
                                "onFailure" : function(f) {
                                    logConsole("onFailure : errorMessage = " + f.errorMessage);
                                }
                            });
                        }else{
                            launchNetflix()
                        }
                    },
                    "onFailure" : function(f) {
                        logConsole("onFailure : errorMessage = " + f.errorMessage);
                    }
                });
                break;
            case hcap.key.Code.RED :
                // CLEAR PORTAL DEBUG PANEL
                if (isDebugOn('portal')) {
                    $("#htmlconsole").toggleClass('hidden');
                    logConsole("Done toggling 'htmlconsole' class 'hidden'");
				}
				else {
	                hcap.key.sendKey({
	                    "virtualKeycode" : hcap.key.Code.SAP,
	                    "onSuccess" : function() {
	                        logConsole("onSuccess");
	                    },
	                    "onFailure" : function(f) {
	                        logConsole("onFailure : errorMessage = " + f.errorMessage);
	                    }
	                });
				}
                break;
            case hcap.key.Code.GREEN :
                // CLEAR INDEX DEBUG PANEL
                if (isDebugOn('index')) {
					$(".index_console", top.document).toggleClass('hidden');
                    logConsole("Done toggling 'index_console' class 'hidden'");
				}
				else {
	                if(typeof adbannerHandler === 'object' && adbannerHandler.isOn) {
	                    adbannerHandler.eventHandler(event.keyCode);
	                }
				}
                break;
            case hcap.key.Code.YELLOW :
                if(typeof adbannerHandler === 'object' && adbannerHandler.isOn) {
                    adbannerHandler.eventHandler(event.keyCode);
                }else {
                    /* disabled for production */
                    if (isDebugOn('portal') || isDebugOn('index') || url.indexOf("stats.html") > -1) {
                    	reboot();
					}
                }
                break;
            case hcap.key.Code.BLUE :
                if(typeof adbannerHandler === 'object' && adbannerHandler.isOn) {
                    adbannerHandler.eventHandler(event.keyCode);
                }
                else {
                    if(PORTAL_ACTIVE) {
                    	logConsole("SECRET_KEY_BUFFER: " + SECRET_KEY_BUFFER);
                    	switch(SECRET_KEY_BUFFER) {
                    		case SECRET_REBOOT_STR:
                            case SECRET_REBOOT_STR_SHORT:
	                            logConsole("Reboot condition met");
                           		reboot();
                    			break;
                    		case SECRET_DEBUG_STR:
                            case SECRET_DEBUG_STR_SHORT:
                        		logConsole("Debug portal condition met");
								toggleDebugPanel();
                    			break;
							case SECRET_DEBUG_INDEX_STR:
                            case SECRET_DEBUG_INDEX_STR_SHORT:
                        		logConsole("Debug index condition met");
								toggleIndexDebugPanel();
								break;
							case SECRET_STATS_PAGE_STR:
                            case SECRET_STATS_PAGE_STR_SHORT:
                        		logConsole("Going to stats page");
								document.location.href = 'stats.html';
								break;
							case SECRET_DEMO_PAGE_STR:
                            case SECRET_DEMO_PAGE_STR_SHORT:
                        		logConsole("Going to demo  page");
								document.location.href = 'debug.html';
								break;
                            case SECRET_SALES_STR:
                            case SECRET_SALES_STR_SHORT:
                                processSalesKey();
                                break;
							case SECRET_RELOAD_STR:
                            case SECRET_RELOAD_STR_SHORT:
							case "735623":
                        		logConsole("Reloading page");
								document.location.reload();
                                break;
                            case SECRET_IOTSETTING_STR:
                            case SECRET_IOTSETTING_STR_SHORT:
                                logConsole("Going to iot setting page");
                                window.parent.postMessage('event_open_iot_setting_page', '*');
                                break;
                            case SECRET_DEBUG_INSPECTOR:
                                hcap.system.setBrowserDebugMode({
                                    "debugMode" : true,
                                    "onSuccess" : function() {
                                       console.log("onSuccess");
                                        console.log("@@@ ENABLE_INSPECTOR : " + localStorage.getItem("ENABLE_INSPECTOR"));
                                       localStorage.setItem("ENABLE_INSPECTOR", "true");
                                       console.log("@@@ AFTER ENABLE_INSPECTOR : " + localStorage.getItem("ENABLE_INSPECTOR"));
                                       reboot();
                                    },
                                    "onFailure" : function(f) {
                                       console.log("onFailure : errorMessage = " + f.errorMessage);
                                    }
                                });
                                break;
                    	}
                    }
                }
                SECRET_KEY_BUFFER = "";
                break;
            case hcap.key.Code.SMART_HOME :
                break;
            case hcap.key.Code.INFO:
                var on_channelbanner = false;
                if(url.indexOf("channelbanner.html") != -1){
                    on_channelbanner = true;
                }

                // In preview mode
                if (isPreviewMode()) {
                    if (settingKeyMapping == 'channelbanner.html') {
                        logConsole("Don't do anything in preview mode");
                        break;
                    }
                    else if (settingKeyMapping != '') {
                        setTimeout(function(){
                            window.location = "portal.html?page="+settingKeyMapping.replace(".html","");
                        }, 250);
                    }
                }
                else {
                    if (settingKeyMapping == 'channelbanner.html') {
                        if (on_channelbanner) {
                            if (isVODPlaying()) {
                               displayBanner();
                            } else {
                               init_channel_banner();
                            }
                        } else {
                            /* Same logic with EXIT key / goto('channelbanner') cannot load channel information */
                            if(typeof adbannerHandler === 'object' && adbannerHandler.isOn) {
                                adbannerHandler.off();
                            }
                            else {
                                // Sync index.html to portal settings
                                SyncBackgroundSettingsToParent('none');
    
                                setTimeout(function() {
                                    SetPortalStatus(HIDE_PORTAL);
                                }, 50);
                            }
                        }
                    }
                    else {
                        if (isVODPlaying()) {
                            //clear media and go to the info page which is set.
                            exitVOD(function() {
                                if(PORTAL_ACTIVE){
                                    goto(settingKeyMapping.replace(".html",""));
                                }else{
                                    setTimeout(function(){
                                        window.location = "portal.html?page="+settingKeyMapping.replace(".html","");
                                    }, 250);

                                    setTimeout(function() {
                                        SetPortalStatus(SHOW_PORTAL);
                                    },50);
                                }
                            }, settingKeyMapping.replace(".html",""));
                        } else {
                            // Sync index.html to portal settings
                            //SyncBackgroundSettingsToParent('portal');

                            if(PORTAL_ACTIVE){
                                goto(settingKeyMapping.replace(".html",""));
                            }else{
                                setTimeout(function(){
                                    window.location = "portal.html?page="+settingKeyMapping.replace(".html","");
                                }, 250);
                                
                                setTimeout(function() {
                                    SetPortalStatus(SHOW_PORTAL);
                                 },50);
                            }
                        }
                    }
                }

                break;
            case hcap.key.Code.INPUT:
                if (!isPreviewMode() && PORTAL_ACTIVE) {
                    setTimeout(function() {
                       SetPortalStatus(HIDE_PORTAL, "INPUT");
                    }, 50);
                } else if(!isVODPlaying()) {
                    addKeyItem(hcap.key.Code.INPUT, 0, function() {
                       hcap.key.sendKey({
                          "virtualKeycode" : hcap.key.Code.INPUT,
                          "onSuccess" : function() {
                          },
                          "onFailure" : function(f) {
                          }
                       });
                    });
                }
                break;
            default:
                break;
        }
    }
    catch(err) {
        logConsole(err.message);
    }
}

function goToReferrerPage(callByExitVOD) {
    logConsole("In goToReferrerPage....................");
    var url = window.location.href;

    var current_page = getCookie("current_page");
    var back_page_referrer = localStorage.getItem("back_page_referrer");
    localStorage.removeItem("back_page_referrer");

    logConsole("current url: " + url);
    logConsole("back_page_referrer: " + back_page_referrer);

    if (!PORTAL_ACTIVE && (getCookie("portal_mode") != PORTAL_MODE_TV || callByExitVOD !== "undefined") && back_page_referrer != "" && back_page_referrer != null) {
        logConsole("hasVideoOrPipWidget: " + pageHasVideoOrPipWidget());
        if (pageHasVideoOrPipWidget() == 'Y') {
            // ON A PAGE WITH PIP/VIDEO WIDGET AND IT'S STILL IN HDMI MODE (CMD USUALLY), GO TO PORTAN THEN
            logConsole("****************  go to portal instead of back_page_referrer: " + back_page_referrer);
            back_page_referrer = 'portal.html';
        }
        else {
            logConsole("****************  back_page_referrer: " + back_page_referrer);
        }

        logConsole("****************    NON-TV MODE, back_page_referrer: " + back_page_referrer);

        PORTAL_ACTIVE = true;
        if(typeof window.parent.PORTAL_ACTIVE != "undefined") {
            window.parent.PORTAL_ACTIVE = true;
        }

        // disable tv_channel_attribute_floating_ui
        TVSetup("tv_channel_attribute_floating_ui", "0", 50);

        addKeyItem(hcap.key.Code.INPUT, 2);

        if(window.parent.GLOBAL_SOUND_SETTING != 2) {
            // Disable subtitle
            if (! IS_MIA_PROJECT) {
                TVSetup("tv_caption_ui", "0", 50);
            }
        }

        if (getCookie("euroGuideButtonSet") == 'true') {
            addKeyItem(hcap.key.Code.GUIDE, 2);
        }

        PORTALTIMEOUT_OFFSET = 0;
        resetTimer();

        if(window.spa) {
            goto(back_page_referrer.replace(".html",""));
            return true;
        }
        // Sync index.html to portal settings
        if(back_page_referrer === "portal.html" && current_page !== "")
            SyncBackgroundSettingsToParent(current_page);
        else
            SyncBackgroundSettingsToParent(back_page_referrer.replace(".html",""));

        resizePIPtoFullScreen();
        localStorage.removeItem("back_page_referrer");
        if (isPreviewMode()) {
            window.location = "src/" + back_page_referrer + "?" + Date.now();
        }
        else {
            setTimeout(function() {
                $(window.frameElement).addClass('hidden');
                if(back_page_referrer === "portal.html" && current_page !== "")
                    window.location = back_page_referrer + "?page=" + current_page;
                else
                    window.location = back_page_referrer + "?" + Date.now();
            }, 250);
        }
        return false;
    }
    return false;
}

function getBackPageReferrer() {
    var back_page_referrer = localStorage.getItem("back_page_referrer");
    var current_page = getCookie("current_page");

    if (getCookie("portal_mode") != PORTAL_MODE_TV && back_page_referrer != "" && back_page_referrer != null) {
        if (pageHasVideoOrPipWidget() == 'Y') {
            back_page_referrer = 'portal';
        } else  {
            if(back_page_referrer === "portal.html" && current_page !== "")
                back_page_referrer = current_page;
        }

        return back_page_referrer;
    } else {
         back_page_referrer = 'portal';
    }
    return back_page_referrer;
}

function portal_startup(){
    var param = {
        "mode":hcap.mode.HCAP_MODE_1,
        "onSuccess":function() { /* logConsole("onSuccess hcap0");*/ },
        "onFailure":function(f) { logConsole("onFailure : errorMessage = " + f.errorMessage);}
    };

    hcap.mode.setHcapMode(param);

    logConsole("PORTALTIMEOUT_OFFSET: " + PORTALTIMEOUT_OFFSET);
    if (PORTALTIMEOUT_OFFSET > 0) {
        setTimeout(function() {
            PORTALTIMEOUT = getCookie("timeout");
            //logConsole("PORTALTIMEOUT from cookie 'timeout' IS: " + PORTALTIMEOUT);

            if (PORTALTIMEOUT == '') {
				PORTALTIMEOUT = 0;
            }
            else {
				PORTALTIMEOUT = parseInt(PORTALTIMEOUT);
            }
            logConsole("PORTALTIMEOUT: " + PORTALTIMEOUT);

            if(PORTAL_ACTIVE && PORTALTIMEOUT > 0){
                resetTimer();
            }
            PORTALTIMEOUT_OFFSET = 0;
            // logConsole("clearing PORTALTIMEOUT_OFFSET: " + PORTALTIMEOUT_OFFSET);
        }, PORTALTIMEOUT_OFFSET - 1);
    }
}

function resetTimer() {
	// logConsole("In resetTimer...");
    if (!isEditorMode() && !isPreviewMode()) {
        clearTimeout(t);

        var url = window.location.href;
        if (url.indexOf("popup_007") == -1) {
            //logConsole("expireCookie('freezetimer')");
            expireCookie("freezetimer");
        }

        tmp_timeout = (PORTALTIMEOUT*1000) - PORTALTIMEOUT_OFFSET;
        //logConsole("resetting timer to: " + tmp_timeout);
        if (tmp_timeout > 0) {
            t = setTimeout(hideBanner, tmp_timeout);
        }
    }
}

function clearTimer() {
    if (!isEditorMode() && !isPreviewMode()) {
        if(typeof t != "undefined") {
            clearTimeout(t);
        }
    }
}

function hideBanner() {
    var smartappTimer = getCookie("smartapp_freezetimer");
    freezetimer = getCookie("freezetimer");
    channelbanner_active = getCookie("channelbanner_active");

    //logConsole("channelbanner_active: " + channelbanner_active);
    //logConsole("freezetimer: " + freezetimer);

    if (smartappTimer == '' && freezetimer == '' && channelbanner_active == '') {
        SetPortalStatus(HIDE_PORTAL);
    }
    else {
        logConsole("{utilities} Timer is FROZEN from popup page or channelbanner! Can't hide portal!", LOG_MESSAGE_TYPES.information);
    }
}

function exitVOD(callback, lookup_page, event_key) {
//logIndexConsole("*------- EXIT VOD ------- *");

    resetTimer();

    //logIndexConsole("expireCookie(channelbanner_active);");
    expireCookie("channelbanner_active");

    var fx = function() {
        setTimeout(function(){
            if(typeof callback === "function") {
               callback();
            } else {
               SetPortalStatus(SHOW_PORTAL);
               goToPortal();
            }
        }, 50);
    };

    setCookie("guide_to_page", "1", 365);
    revert_portal_mode = getLocalStorageObject('revert_portal_mode');
    if ($.isPlainObject(revert_portal_mode) && !$.isEmptyObject(revert_portal_mode)) {
        logConsole("revert_portal_mode.portal_mode: " + revert_portal_mode.portal_mode);
        switch(revert_portal_mode.portal_mode) {
            case "tv":
                if(event_key == hcap.key.Code.GUIDE && !_.isUndefined(event_key)){
                    logical_channel = parseInt(getCookie("guideButtonChannel"));
                }else{
                    logical_channel = revert_portal_mode.channel;
                }

                logConsole("******* logical_channel: " + logical_channel + "********");
                if (logical_channel != '') {
                    ch = getPhysicalChannelInfo(parseInt(logical_channel));

                    if (!_.isUndefined(ch) && !_.isEmpty(ch)) {
                        setBackgroundToBlack();
                        if(typeof lookup_page !== "undefined") {
                           SyncBackgroundSettingsToParent(lookup_page);
                        } else {
                           SyncBackgroundSettingsToParent("portal");
                        }
                        clearMedia(fx);

                        // changeChannel(ch, 0, fx);
                        return;
                    }
                }
                break;
            case "hdmi1":
            case "hdmi2":
            case "hdmi3":
                if(typeof lookup_page !== "undefined") {
                   SyncBackgroundSettingsToParent(lookup_page);
                } else {
                   SyncBackgroundSettingsToParent("portal");
                }
                clearMedia(fx);

                switchMode(revert_portal_mode.portal_mode);
                break;
        }
    }
    else {
        logConsole("Unable to find revert_portal_mode object in localStorage...");
    }
}
